﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
	
	
#End Region



Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Public Localisation_Home As String=""
	Dim phone1 As Phone
	Public level_battery As Int=0
	Public Local_sensor As String=""
	Public T_consigne As String=""
	Public nb_sensor As Int=0
	Public Download_File_HH, Upload_File_HH,Download_Setup_HH,Load_Data_SAV_HH,Save_Data_SAV_HH As Int
	Public Macaddress As String
	Public Timer1 As Timer
	Public Timer2 As Timer
	
	Dim LiveTemp As Double
	
	Download_File_HH=1
	Upload_File_HH=2
	Download_Setup_HH=3
	Load_Data_SAV_HH=5
	Save_Data_SAV_HH=6
	
	Public SetupReadJsonList As List
	Public SensorReadJsonList As List
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private clv_sensor As CustomListView
	Dim cs As CSBuilder
	
	
	Private Btn_setup_sensor As B4XView
	Private lbl_icone_sensor As B4XView
	Private lbl_name As AutoTextSizeLabel
	Private lbl_T_Consigne As AutoTextSizeLabel
	Private lbl_T_live As AutoTextSizeLabel
	Private Lbl_alerte As B4XView
	Private Lbl_alerte1 As B4XView
	
	
	
	Dim filetotransfert As String=""
	Private lbl_icone_humidity As B4XView
	Private lbl_H_live As AutoTextSizeLabel
	
	
	Private Lbl_update As AutoTextSizeLabel
	Private Old_Data As Boolean=False
	
	Private Btn_save_sensor As B4XView
	Private  save_data_sav As Boolean=False
	Private Btn_trash As B4XView
	Private Lbl_verif_data_cloud As B4XView
	Private Btn_conso As B4XView
	Private lbl_conso As B4XView
	Private Btn_graphe As B4XView
	Private Btn_alert As B4XView
	Private Var_temp As RoundSlider
	
	
	
		
	Private Btn_conso1 As B4XView
	Private Btn_graphe1 As B4XView
	Private Btn_setup_sensor1 As B4XView
	
	Private SelectIndexSensor As Int =-1
	Private LblBatLevel As B4XView
	Private LblFire As B4XView
	Private BtnBack As B4XView
	Private LblbatAff As B4XView
	Private LblSetT As B4XView
	Private LblInfoMess As B4XView
	Private LblInfoMode As B4XView
	Private LblInfoPilotage As B4XView
	Private LblInfoTmax As B4XView
	Private dialogAlerte As B4XDialog
End Sub



Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("HomeControl1")
	Timer1.Initialize("timer1", 15000)
	Timer2.Initialize("timer2", 300)
	
	' Chargement de la configuration et des datas sur le serveur.
	SensorReadJsonList.Initialize
	SetupReadJsonList.Initialize
	
	If Main.new_location=False Then ' Si ce n'est pas une nouvelle configuration
		If IsPaused(Transfert_Server)=True Then
			Lbl_verif_data_cloud.Visible=True
			Main.type_transfert=Download_Setup_HH
			StartService(Transfert_Server)
		End If
	End If
	
	'*******************Initialisation des boites de dialogues
	
	
	dialogAlerte.Initialize(Activity)
	dialogAlerte.BorderColor=0xFFE20F0F
	dialogAlerte.TitleBarColor=0xFF9E0000
	dialogAlerte.ButtonsTextColor=0xFFD0D0D0
	dialogAlerte.BodyTextColor=0xFFD0D0D0
	dialogAlerte.TitleBarTextColor=0xFFD0D0D0
	
		
End Sub

Sub Activity_Resume
	If Setup_Power_connected.Update_data_sensor_enable=True Then
		Lbl_verif_data_cloud.Visible=True
	End If
	StopService(Scan_Power)
	StopService(TPL_Echange)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	StopService(Scan_Power)
	StopService(TPL_Echange)
	StopService(Transfert_Server)
	
End Sub


Sub lbAddSensor_Click
	StartActivity(Setup)
End Sub


Sub Timer2_Tick
	If Lbl_verif_data_cloud.Visible=True Then
		Lbl_verif_data_cloud.Visible=False
		Lbl_verif_data_cloud.RequestFocus
	Else
		Lbl_verif_data_cloud.Visible=True
		Lbl_verif_data_cloud.RequestFocus
	End If
End Sub

Sub Timer1_Tick
	
	If Setup_Power_connected.Update_data_sensor_enable=False Then 'Stop le timer une fois le fichier téléchargé
		Timer1.Enabled=False
		Timer2.Enabled=False
	Else
'		If Timer2.Enabled=False Then
'			Timer2.Enabled=True
'		End If
		
		If IsPaused(Transfert_Server)=True Then
			Lbl_verif_data_cloud.Visible=True
			Main.type_transfert=Download_Setup_HH
			StartService(Transfert_Server)
		End If
	End If
	
End Sub

'*************************** Eum Json Sensor File**************************

Sub Read_JSONfile_Sensor(file_name As String) As ResumableSub
	
	wait for (Param.Read_JSONfile(file_name)) complete  (listTemp As List)
	
	SensorReadJsonList.Clear
	SensorReadJsonList.Addall(listTemp)
	
	Dim MapDataSensor As Map
	Dim SetupMapDataSensor As Map
	Dim Num As Int=1
	Dim NumList As Int=0
	'LiveTemp=0
	'Ennumère la liste de Sensors dans l'ordre
	clv_sensor.Clear
	Do While NumList< SensorReadJsonList.Size
		
		For Each L_Map As Map In SensorReadJsonList
			
			If L_Map.ContainsKey("Sensor " & Num)Then
				MapDataSensor= L_Map.Get("Sensor " & Num)
				'Dim Loc As String = MapDataSensor.Get("Localisation")
				'Log(Loc)
				
				' Récupère dans le setup le mode de controle pour activer ou pas le réglage Type "Set Control"
				For Each L_Map As Map In SetupReadJsonList
								
					SetupMapDataSensor= L_Map.Get(L_Map.GetKeyAt(0))
						
					If MapDataSensor.Get("SensorMacAddress")= SetupMapDataSensor.Get("SensorMacAddress") Then
					
						Dim info_sensor As String=MapDataSensor.Get("Localisation") &";" & MapDataSensor.Get("SensorMacAddress") &";" & MapDataSensor.Get("TLive") _
				 		&";" & MapDataSensor.Get("Hydro") &";" & MapDataSensor.Get("SetTemp") &";" & MapDataSensor.Get("Battery") &";" & MapDataSensor.Get("TimeStamp") & ";" & SetupMapDataSensor.Get("Control_Type") & ";" & SetupMapDataSensor.Get("SetTemp")' & ";" & data_setup
						clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
						'Num=Num+1
						NumList=NumList+1
						Exit
					End If
				Next
			
			Else 
				'Log("Pas trouvé")
			End If
		Next
		Num=Num+1
	Loop
	Lbl_verif_data_cloud.Visible=False
	Return True
	
End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
	
	
	Select KeyCode
		Case KeyCodes.KEYCODE_VOLUME_UP
			Log("Up")
			Return True
					
		Case KeyCodes.KEYCODE_VOLUME_DOWN
			Log("Down")
			Return True
		Case KeyCodes.KEYCODE_BACK
'			confirme_retour=confirme_retour+1
'			If confirme_retour=2 Then
'				
			'Return True
'				confirme_retour=0
'				
'			Else
'				ToastMessageShow("Appuyer sur la touche retour une seconde fois pour quitter.",True)
'			End If
			
			If save_data_sav = False And IsPaused(Transfert_Server)=True Then
				Return False
			Else
				ToastMessageShow("Veuillez patienter...",False)
				Return True
			End If
		
			'Return True
	End Select
End Sub

'*************************Chargement Setup Json*********************

Sub load_setup(success As Boolean)
		
	If success=True Then
			
		Dim JSON_file_Setup As String = Main.Localisation_Home & "_" & "setup.json"
		wait for (Param.Read_JSONfile(JSON_file_Setup)) complete  (listTemp As List)
		
		If listTemp.Size<>0 Then
			SetupReadJsonList.AddAll(listTemp)
		End If
		
	End If	
	
End Sub

Sub Get_Data_Setup(Mac_Sensor As String) As ResumableSub
	
	' Retourne le setup du sensor selectionné
	Dim data_sensor_setup As String
	For i=0 To Main.list_Read_Setup.Size-1
		Dim data() As String =Regex.Split(";", Main.list_Read_Setup.Get(i))
		
		If data(2)=Mac_Sensor Then
			data_sensor_setup=Main.list_Read_Setup.Get(i)
		End If
				
	Next
	
	Return data_sensor_setup
	
End Sub

Sub alerte (success As Boolean)
	If success=False Then
		Lbl_alerte.Visible=True
		Lbl_alerte1.Visible=True
	Else
		Lbl_alerte.Visible=False
		Lbl_alerte1.Visible=False
	End If
	
	
End Sub



Sub CreateListItem(Text As String, Width As Int, Height As Int) As Panel
	Dim xui As XUI
	Dim p As B4XView =xui.CreatePanel("")
	Dim info_temp() As String=Regex.Split(";",Text)
	Dim TempLive As Double
	Dim Thermostat As Double
	
	p.SetLayoutAnimated(0,0,0,Width,Height)
	p.LoadLayout("List_sensor")
	
	lbl_name.Text=""
	lbl_T_live.Text=""
	lbl_H_live.Text=""
	lbl_T_Consigne.Text=""
	lbl_T_live.BaseLabel.Tag=""
	lbl_H_live.BaseLabel.Tag=""
	LblbatAff.Text=""
	
	'level_battery=0
	
	
	If Old_Data=True Then
		Lbl_update.BaseLabel.TextColor=Colors.Red
	Else
		Lbl_update.BaseLabel.TextColor=Colors.Black
	End If
	
		
	Try
		
		lbl_icone_sensor.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF01FF20).Size(40).Append(Chr(0xF2C9) ).PopAll
		lbl_icone_humidity.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(30).Append(Chr(0xF043) ).PopAll
		
		
		
		If info_temp.Length>=8 Then 'Vérifie de la bonne dimension du tableau
			
			
			Lbl_update.Text=info_temp(6)
			lbl_name.Text=info_temp(0)
			lbl_name.tag=info_temp(1)
			
			If info_temp(2)<>"T=100" Then
								
				lbl_T_live.Text = info_temp(2).SubString(2) & "°C" 'Température Live
				lbl_H_live.BaseLabel.Tag = info_temp(2).SubString(2) 'stock la Température Live
				lbl_H_live.Text= info_temp(3).SubString(2) & "%" 'Hydrométrie
				Dim Temp() As String=Regex.Split("=",info_temp(2))
				TempLive =Temp(1)
			Else
				lbl_T_live.Text =cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(20).Append(Chr(0xF071) ).PopAll
				lbl_H_live.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(20).Append(Chr(0xF071) ).PopAll
				lbl_H_live.BaseLabel.Tag = info_temp(2).SubString(2)
				TempLive=100
			End If
				
			
			lbl_T_Consigne.BaseLabel.Tag= info_temp(4)
			lbl_T_Consigne.Text = "T Max: " & info_temp(4) & "°C"' Round2(info_temp(4),1) & "°C" 'Round2(info_temp(3),1) & "°C"
			If info_temp(5).Replace("%","")="-" Then
				lbl_T_live.BaseLabel.Tag=1000
			Else
				lbl_T_live.BaseLabel.Tag= info_temp(5).Replace("%","") 'Mémorise le niveau de batterie dans le tag de la température
			End If
			'lbl_T_live.Tag= info_temp(5).Replace("%","") 'Mémorise le niveau de batterie dans le tag de la température
			
			Dim LevelBat As Int = lbl_T_live.BaseLabel.Tag
			
			Dim Thermostat As Double = info_temp(8)
			
			
			
				' non utilisé
'				If info_temp(7)="1" Then
'					Btn_alert.Visible=False
'					Btn_alert.RequestFocus
'					
'										
'				Else if info_temp(7)="2" Then
'					Btn_alert.Visible=True
'					Btn_alert.RequestFocus
'					clv_sensor.Refresh										
'				End If
			
			' Affiche le réglage de la température dans l'icone écran principal				
			LblSetT.Text=info_temp(8) & "°c"
			
			' Level Batterie
			LblbatAff.Text= LevelBat & "%"
			LblbatAff.TextSize=11
			LblbatAff.TextColor=0xFF414141
			
			If LevelBat=1000 Then
				LblbatAff.Text= ""
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFFFF0000).Size(30).Append(Chr(0xE1A6) ).PopAll
			Else If LevelBat>75 Then
				If LevelBat=100 Then
					LblbatAff.TextSize=9
				End If
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF29DF00).Size(25).Append(Chr(0xF240) ).PopAll
			Else if LevelBat >50 And LevelBat<=75 Then
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF29DF00).Size(25).Append(Chr(0xF241) ).PopAll
			Else if LevelBat >25 And LevelBat<=50 Then
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF29DF00).Size(25).Append(Chr(0xF242) ).PopAll
			Else if LevelBat >=5 And LevelBat<25 Then
				LblbatAff.TextColor=0xFFFFFFFF
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(25).Append(Chr(0xF243) ).PopAll
			Else if LevelBat<5 Then
				LblbatAff.TextColor=0xFFFFFFFF
				LblBatLevel.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(25).Append(Chr(0xF244) ).PopAll
			End If
			
			'Notif chauffage actif
			If (Thermostat>TempLive And TempLive<>100) And Btn_alert.Visible=False Then
				LblFire.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFFBD00).Size(30).Append(Chr(0xF06D)).PopAll
			Else
				LblFire.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(30).Append(Chr(0xF06D)).PopAll
			End If
			
			
		Else
			lbl_icone_sensor.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(40).Append(Chr(0xF071) ).PopAll
		End If
		
		
	Catch
		Log(LastException)
		
	End Try
	
	
	Return p
	
End Sub

'non utilisé
Sub Btn_setup_sensor_Click
	
	Dim Index_Sensor As Int= clv_sensor.GetItemFromView(Sender)
	Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
	Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
	
	If lbl.Tag="-" Then
		level_battery = 100 'Fixe le niveau à 100% si la toute première mesure est ko
	Else
		level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
	End If
	
	
	lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
	Local_sensor=lbl.Text
	Macaddress=lbl.tag
	lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
	T_consigne=lbl.tag
	StartActivity(Setup_Power_connected)
	
End Sub
'non utilisé
Sub Btn_conso_Click
	Dim Index_Sensor As Int= clv_sensor.GetItemFromView(Sender)
	Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
	Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
	Dim lbl1 As Label= pnl.GetView(5)
	If lbl.Tag="-" Then
		level_battery = 100 'Fixe le niveau à 100% si la toute première mesure est ko
	Else
		level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
	End If
	
	LiveTemp= lbl1.Tag
	lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
	Local_sensor=lbl.Text
	Macaddress=lbl.tag
	lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
	T_consigne=lbl.tag
	StartActivity(Power_Interface)
End Sub
'non utilisé
Private Sub Btn_graphe_Click
	
	Dim Index_Sensor As Int= clv_sensor.GetItemFromView(Sender)
	Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
	Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
	
	If lbl.Tag="-" Then
		level_battery = 100 'Fixe le niveau à 100% si la toute première mesure est ko
	Else
		level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
	End If
	
	
	lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
	Local_sensor=lbl.Text
	Macaddress=lbl.tag
	lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
	T_consigne=lbl.tag
	StartActivity(Stattistiques)
	
End Sub

'*******************Charge le menu dans la selection*****************

Private Sub clv_sensor_ItemClick (Index As Int, Value As Object)
	
	Dim Index_Sensor As Int= Index
		Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
		Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
		Dim lbl1 As Label= pnl.GetView(5)
		
		If lbl.tag<>"" Then
		If lbl.Tag="-" Then
			level_battery = 100 'Fixe le niveau à 100% si la  mesure est ko
		Else
			level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
		End If
		
		If lbl1.Tag="-" Then
			LiveTemp=100 'Fixe la valeur à 100 si la  mesure est ko
		Else
			LiveTemp= lbl1.Tag
		End If
		
		lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
		Local_sensor=lbl.Text
		Macaddress=lbl.tag
		lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
		T_consigne=lbl.tag
	End If
	
	'wait for (ReloadListSensor) complete (result As Boolean)
	
	'Dim fileSensor As String="AMIENS_Data_Live_Sensor.json"
	'wait for (Read_JSONfile_Sensor(fileSensor)) complete (result As Boolean)
	If SelectIndexSensor<> Index Then
		wait for (ReloadListSensor) complete (result As Boolean)
		Dim xui As XUI
		Dim p1 As B4XView =xui.CreatePanel("")
		p1.SetLayoutAnimated(0,0,0,clv_sensor.AsView.Width,10dip)
		p1.LoadLayout("OptionCockpit")
		p1.Height=1dip
		p1.Color=0xFF343434
		p1.Visible=True
		
		clv_sensor.ReplaceAt(Index,p1,120dip,"")
		SelectIndexSensor=Index
	Else
		SelectIndexSensor=-1
	End If
	
End Sub

Private Sub Btn_setup_sensor1_Click
	StartActivity(Setup_Power_connected)
End Sub

Private Sub Btn_graphe1_Click
	StartActivity(Stattistiques)
End Sub

Private Sub Btn_conso1_Click
	If LiveTemp<>100 Then
		StartActivity(Power_Interface)
	Else
		dialogAlerte.Title="Impossible d'acceder à l'interface"
		Wait For (dialogAlerte.Show("La sonde de température ne répond pas.","Ok","","")) Complete (Result As Int)
	End If
	
End Sub

Private Sub BtnBack_Click
	wait for (ReloadListSensor) complete (result As Boolean)
End Sub

Sub ReloadListSensor As ResumableSub
	Dim fileSensor As String= Main.Localisation_Home & "_Data_Live_Sensor.json"
	Read_JSONfile_Sensor(fileSensor) 
	SelectIndexSensor=-1
	Return True	
End Sub

Private Sub LblInfoTmax_Click
	
End Sub

Private Sub LblInfoPilotage_Click
	
End Sub

Private Sub LblInfoMode_Click
	
End Sub

Private Sub LblInfoMess_Click
	
End Sub